import gzip

def out(path):

   if path.endswith(".gz"):
      file = gzip.open(path)
   else:
      file = open(path)

   devfm40 = []
   devfmall = []
   testfm40 = []
   testfmall = []
   all = [devfmall, devfm40, testfmall, testfm40]

   for line in file:
      if line.startswith("Test iteration"):
         ite = int(line.split()[-1])
         assert ite == len(devfmall)+1
         next_fill = 0
         next_add = 0
      elif line.startswith("Parsing has finished"):
         assert next_add == 0 or next_add == 2
         if next_add == 2 and next_fill == 0:
            next_fill = 2
         all[next_add].append(-1)
         next_add += 1
         all[next_add].append(-1)
         next_add += 1
      elif line.startswith("Bracketing FMeasure"):
         fm = float(line.split()[-1])
         all[next_fill][-1]=fm
         next_fill += 1
   file.close()

   maxfm = -1
   maxindex = -1
   for index in range(len(devfmall)):
      if devfmall[index] > maxfm:
         maxfm = devfmall[index]
         maxindex = index
   print "Maximum iteration: ", maxindex
   print "Max dev FMeasure:", devfmall[maxindex]
   print "Max dev FMeasure (<=40 words):", devfm40[maxindex]
   print "Max test FMeasure:", testfmall[maxindex]
   print "Max test FMeasure (<=40 words):", testfm40[maxindex]

if __name__ == '__main__':
   import sys
   out(sys.argv[1])
