// Copyright (C) Institute 2010

/****************************************************************
 *                                                              *
 * definitions.h - the general definitions                      *
 *                                                              *
 * Author: Author                                            *
 *                                                              *
 * Computing Laboratory, Institute. 2006.10                        *
 *                                                              *
 ****************************************************************/

#ifndef DEFINITIONS_H
#define DEFINITIONS_H

/*===============================================================
 *
 * The things that should be included 
 *  
 *==============================================================*/

#include <cstdlib>                              // define NULL
#include <utility>                              // define std::pair
#include <cassert>                              // assert
#include <ctime>                                // clock(); CLK_TCK
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <iostream>
#include <fstream>
#include <sstream>
#include <exception>
#include <algorithm>

//using namespace std;

/*===============================================================
 *
 * debugging utilities
 *  
 *==============================================================*/

// throw
#define THROW(x) { std::ostringstream __tmp_os; __tmp_os << x; throw(__tmp_os.str()); }

// assert
#define ASSERT(x,y) { if (!(x)) THROW(y); }

// error report tool
#define REPORT(x) { std::cerr << std::endl << "In " << __FILE__ << ", line " << __LINE__ << ": " << std::endl << x << std::endl; std::cerr.flush(); }
#define WARNING(x) { std::cerr << "Warning:" << " " << x << std::endl; std::cerr.flush(); }

// trace tool
#ifdef DEBUG 
#define TRACE(x) { std::cout << x << std::endl; std::cout.flush(); }
#define TRACE_WORD(x) { std::cout << x; std::cout.flush(); }
#else
#define TRACE(x) 
#define TRACE_WORD(x)
#endif

// conditional compiling
#ifdef DEBUG
#define WHEN_DEBUGGING(x) x
#else
#define WHEN_DEBUGGING(x) 
#endif

/*===============================================================
 *
 * definitions abstd::cout sentence structures 
 *  
 *==============================================================*/

#include "linguistics/sentence_string.h"

#endif

